<!DOCTYPE html>
<html lang="en">

<head>
	<title>Product line CRUD</title>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">

	<link rel="stylesheet" href="mystyle.css">
	<script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.24.0/moment.min.js"></script>
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>

	<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
	<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />


	<!-- Import Datatable sau jquery -->
	<!-- Import them style bootstrap cho datatable -->
	<link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
	<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
	<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

</head>

<body>

	<div class="container">
		<h2 style="text-align: center;">Quản trị Product line</h2>

		<!-- Create voucher modal -->
		<div>
			<div id="create-product-line-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Create new office</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>productLine</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-productLine" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>description</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-description" class="form-control">
									</div>
								</div>







							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-secondary" id="btn-create-cancel"
								data-dismiss="modal">Cancel</button>
							<button class="btn btn-primary" id="btn-create-product-line">Create Product line</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Update voucher modal -->
		<div>
			<div id="update-customer-modal" class="modal fade" tabindex="-1">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Update Product line</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<form>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>productLine</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-productLine-update" class="form-control">
									</div>
								</div>
								<div class="row form-group">
									<div class="col-sm-3">
										<label>description</label>
									</div>
									<div class="col-sm-9">
										<input type="text" id="input-description-update" class="form-control">
									</div>
								</div>







							</form>
						</div>
						<div class="modal-footer">
							<button class="btn btn-secondary" id="btn-create-cancel"
								data-dismiss="modal">Cancel</button>
							<button class="btn btn-primary" id="btn-update-product-line">Update Product line</button>
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- Delete confirm modal -->
		<div>
			<div class="modal fade" tabindex="-1" id="delete-modal">
				<div class="modal-dialog">
					<div class="modal-content">
						<div class="modal-header">
							<h5 class="modal-title" id="h5-modal-title">Product line Delete Confirmation</h5>
							<button class="close" data-dismiss="modal">&times;</button>
						</div>
						<div class="modal-body">
							<label>Bạn có chắc chắn muốn xóa product line này không?</label>
						</div>
						<div class="modal-footer">
							<button class="btn btn-danger" id="btn-confirm-delete-product-line">Confirm</button>
							<button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
						</div>
					</div>
				</div>
			</div>
		</div>
		<button class="btn btn-success " id="create-product-line">Add Product line</button>
		<table class="table table-bordered table-striped table-hover" id="office-product-line">
			<thead>
				<tr>
					<th>STT</th>
					<th>productLine</th>
					<th>description</th>

					<th>Action</th>
				</tr>
		</table>
	</div>
	<script>
		/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
		// Biến mảng hằng số chứa danh sách tên các thuộc tính
		const gPRODUCT_LINE_COLS = ["id", "productLine", "description", "action"];

		// Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
		const gPRODUCT_LINE_STT_COL = 0;
		const gPRODUCT_LINE_LINE_STT_COL = 1
		const gPRODUCT_DES_STT_COL = 2;
		const gPRODUCT_ACTION_STT_COL = 3;


		var table = $("#office-product-line").DataTable({
			columns: [
				{ data: gPRODUCT_LINE_COLS[gPRODUCT_LINE_STT_COL] },
				{ data: gPRODUCT_LINE_COLS[gPRODUCT_LINE_LINE_STT_COL] },
				{ data: gPRODUCT_LINE_COLS[gPRODUCT_DES_STT_COL] },
				{ data: gPRODUCT_LINE_COLS[gPRODUCT_ACTION_STT_COL] },

			],
			columnDefs: [
				{ // định nghĩa lại cột action
					targets: gPRODUCT_ACTION_STT_COL,
					defaultContent: `
					<i class="fas fa-edit edit-product-line"></i>
					<i class="fas fa-trash-alt delete-product-line"></i>
			  
			`
				}
			]
		})
		var gRowSelected = ''
		var glistAlbum = [];
		var gProductLinedSelected = '';
		var gRowCustomerSelected = '';
		var glistAlbumValidateUpdate = [];
		/*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
		$(document).ready(function () {
			onPageLoading();
			//create new album
			$('#create-product-line').on('click', function () {

				onBtnAddProductLineClick();
			})
			$('#btn-create-product-line').on('click', function () {

				onBtnCreateProductLineOnModalClick();
			})
			//edit album
			$('#office-product-line').on('click', '.edit-product-line', function () {

				onBtnEditProductClick(this);
			})
			$('#btn-update-product-line').on('click', function () {
				onBtnUpdateOnModalClick()
			})

			//xóa album
			$('#office-product-line').on('click', '.delete-product-line', function () {

				onBtnDeleteOfficeClick(this);
			})
			$('#btn-confirm-delete-product-line').on('click', function () {

				onBtnConfirmOnDeleteModalClick(this);
			})




		})
		/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
		//hàm gọi api load danh sách album từ server khi tải trang
		function onPageLoading() {
			console.log('làm toi day')
			$.ajax({
				url: "http://localhost:8080/product_line/all",
				type: "GET",
				dataType: "json",
				success: function (res) {
					glistAlbum = res
					console.log('check data get all product from server', res);
					table.clear();
					table.rows.add(res);
					table.draw();
				},
				error: function (err) {
					console.log(err.response);
				}
			})
		}
		//hàm thực hiện khi nhấn nút add new album
		function onBtnAddProductLineClick() {

			$("#create-product-line-modal").modal("show");

		}
		//hàm thực hiện khi nhấn create album trên modal
		function onBtnCreateProductLineOnModalClick() {
			createNewProductLine();
			$("#create-product-line-modal").modal("hide");
		}
		//hàm thực hiện khi lúc nút edit
		function onBtnEditProductClick(paramButton) {
			$("#update-customer-modal").modal("show");
			gProductLinedSelected = getCustomerIdFromButton(paramButton)

			console.log('check id office selected', gProductLinedSelected)
			callApiToGetProductLIneById(gProductLinedSelected)
		}
		//hàm thực hiện khi nhấn nút update trên modal
		function onBtnUpdateOnModalClick() {
			updateProductLine(gProductLinedSelected);
			$("#update-customer-modal").modal("hide");

		}
		//Hàm thực hiện khi nhấn nút delete
		function onBtnDeleteOfficeClick(paramButton) {
			$("#delete-modal").modal("show");
			gProductLinedSelected = getCustomerIdFromButton(paramButton)

		}
		//hàm thực hiện khi nhấn nút confirm trên delete modal
		function onBtnConfirmOnDeleteModalClick() {
			deletedProductLine();
			$("#delete-modal").modal("hide");

		}
		/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
		//hàm trả ra id album khi nhấn nút edit
		function getCustomerIdFromButton(paramButton) {
			var vTableRow = $(paramButton).parents("tr");
			gRowCustomerSelected = table.row(vTableRow).data();
			console.log(gRowCustomerSelected.id);
			return gRowCustomerSelected.id;
		}
		//hàm gọi api để lấy album cần edit theo id
		function callApiToGetProductLIneById(id) {

			$.ajax({
				url: `http://localhost:8080/product_line/details/${id}`,
				async: false,
				type: "GET",
				dataType: "json",
				success: function (res) {
					console.log('check data office need to update ress', res);
					if (glistAlbum && glistAlbum.length > 0) {
						glistAlbum.map((item, index) => {
							if (item.id == res.id) {
								glistAlbum.splice(index, 1)
							}
						})
					}
					showDataUpdateOnForm(res);
				},
				error: function (err) {
					console.log(err.response);
				}
			})

		}
		//hàm hiển thị data lên form edit
		function showDataUpdateOnForm(paramAlbum) {

			$('#input-productLine-update').val(paramAlbum.productLine);
			$('#input-description-update').val(paramAlbum.description);

		}

		function updateProductLine(paramOfficeId) {
			let objData = {
				productLine: "",

				description: '',
			}
			let objDataFromForm = getDataOnFormUpdate(objData);
			callApiToUpdateData(paramOfficeId, objDataFromForm);
			onPageLoading();
			// var vCheck = validateDataOnform(objDataFromForm);
			// if (vCheck) {
			// 	let albumExist = '';
			// 	if (glistAlbum && glistAlbum.length > 0) {

			// 		for (let i = 0; i < glistAlbum.length; i++) {
			// 			if (glistAlbum[i].albumCode == objDataFromForm.albumCode) {
			// 				alert("Album existed");
			// 				albumExist = glistAlbum[i];
			// 				console.log('Album existed', albumExist)
			// 			}
			// 		}

			// 	}
			// 	if (albumExist == '') {

			// 		callApiToUpdateData(paramOfficeId, objDataFromForm);
			// 		onPageLoading();
			// 	}



			// }
		}




		//hàm thu thập dư liệu trên form update
		function getDataOnFormUpdate(obj) {


			obj.productLine = $('#input-productLine-update').val();
			obj.description = $('#input-description-update').val();
			return obj
		}
		//hàm gọi api để update album
		function callApiToUpdateData(id, paramOrderObject) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/product_line/update/${id}`,
				type: 'PUT',
				async: false,
				contentType: "application/json;charset=UTF-8",
				data: JSON.stringify(paramOrderObject),
				success: function (res) {
					console.log('check data update response', res);

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}

		//save new album
		function createNewProductLine() {
			let objData = {

				productLine: "",

				description: '',


			}
			let objDataFromForm = getDataOnForm(objData);
			callApiToPostData(objDataFromForm);
			onPageLoading();
			// var vCheck = validateDataOnform(objDataFromForm);
			// if (vCheck) {
			// 	if (glistAlbum && glistAlbum.length > 0) {
			// 		glistAlbum.map(item => {
			// 			if (item.albumCode == objDataFromForm.albumCode) {
			// 				alert("Album existed")
			// 			} else {
			// 				console.log('check data post', objDataFromForm)
			// 				callApiToPostData(objDataFromForm);
			// 				onPageLoading();

			// 			}
			// 		})
			// 	}

			// }

		}
		//hàm thực hiện validate dữ liệu trên form
		// function validateDataOnform(paramObjData) {
		// 	if (!paramObjData.albumCode) {
		// 		alert('Missing album code')
		// 		return false;
		// 	}
		// 	if (!paramObjData.albumName) {
		// 		alert('Missing album name')
		// 		return false;
		// 	}
		// 	if (!paramObjData.description) {
		// 		alert('Missing description')
		// 		return false;
		// 	}
		// 	return true;


		// }
		//hàm thu thập dư liệu trên form
		function getDataOnForm(obj) {



			obj.productLine = $('#input-productLine').val();
			obj.description = $('#input-description').val();

			return obj
		}
		//hàm gọi api để tạo album mới
		function callApiToPostData(paramOrderObject) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/product_line/create`,
				type: 'POST',
				async: false,
				contentType: "application/json;charset=UTF-8",
				data: JSON.stringify(paramOrderObject),
				success: function (res) {

					console.log('check data post response', res);

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}
		function deletedProductLine() {
			callApiToDeleteData(gProductLinedSelected);
			onPageLoading();
		}
		function callApiToDeleteData(id) {
			$.ajax({
				async: false,
				url: `http://localhost:8080/productline/delete/${id}`,
				type: 'DELETE',
				async: false,
				// contentType: "application/json;charset=UTF-8",
				// data: JSON.stringify(paramOrderObject),
				success: function (res) {
					alert('Delete success')

				},
				error: function (error) {
					console.assert(error.responseText)
				}
			})
		}


	</script>
</body>

</html>